<?php					// -*-c++-*-
// by Edd Dumbill (C) 1999-2002
// <edd@usefulinc.com>
// $Id: xmlrpc.inc,v 1.50 2005/06/27 14:33:54 ggiunta Exp $


// Copyright (c) 1999,2000,2002 Edd Dumbill.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//    * Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//    * Redistributions in binary form must reproduce the above
//      copyright notice, this list of conditions and the following
//      disclaimer in the documentation and/or other materials provided
//      with the distribution.
//
//    * Neither the name of the "XML-RPC for PHP" nor the names of its
//      contributors may be used to endorse or promote products derived
//      from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.

	if (!function_exists('xml_parser_create'))
	{
		// Win 32 fix. From: 'Leo West' <lwest@imaginet.fr>
		if($WINDIR)
		{
			dl('php3_xml.dll');
		}
		else
		{
			dl('xml.so');
		}
	}

	// G. Giunta 2005/01/29: declare global these variables,
	// so that xmlrpc.inc will work even if included from within a function
	// Milosch: Next round, maybe we should explicitly request these via $GLOBALS where used.
	global $xmlrpcI4;
	global $xmlrpcInt;
	global $xmlrpcDouble;
	global $xmlrpcString;
	global $xmlrpcDateTime;
	global $xmlrpcBase64;
	global $xmlrpcArray;
	global $xmlrpcStruct;

	global $xmlrpcTypes;
	global $xmlEntities;
	global $xmlrpcerr;
	global $xmlrpcstr;
	global $xmlrpc_defencoding;
	global $xmlrpc_internalencoding;
	global $xmlrpcName;
	global $xmlrpcVersion;
	global $xmlrpcerruser;
	global $xmlrpcerrxml;
	global $xmlrpc_backslash;
	global $_xh;

	$xmlrpcI4='i4';
	$xmlrpcInt='int';
	$xmlrpcBoolean='boolean';
	$xmlrpcDouble='double';
	$xmlrpcString='string';
	$xmlrpcDateTime='dateTime.iso8601';
	$xmlrpcBase64='base64';
	$xmlrpcArray='array';
	$xmlrpcStruct='struct';

	$xmlrpcTypes=array(
		$xmlrpcI4       => 1,
		$xmlrpcInt      => 1,
		$xmlrpcBoolean  => 1,
		$xmlrpcString   => 1,
		$xmlrpcDouble   => 1,
		$xmlrpcDateTime => 1,
		$xmlrpcBase64   => 1,
		$xmlrpcArray    => 2,
		$xmlrpcStruct   => 3
	);

	$xmlEntities=array(
		'amp'  => '&',
		'quot' => '"',
		'lt'   => '<',
		'gt'   => '>',
		'apos' => "'"
	);

	$xmlrpcerr['unknown_method']=1;
	$xmlrpcstr['unknown_method']='Unknown method';
	$xmlrpcerr['invalid_return']=2;
	$xmlrpcstr['invalid_return']='Invalid return payload: enable debugging to examine incoming payload';
	$xmlrpcerr['incorrect_params']=3;
	$xmlrpcstr['incorrect_params']='Incorrect parameters passed to method';
	$xmlrpcerr['introspect_unknown']=4;
	$xmlrpcstr['introspect_unknown']="Can't introspect: method unknown";
	$xmlrpcerr['http_error']=5;
	$xmlrpcstr['http_error']="Didn't receive 200 OK from remote server.";
	$xmlrpcerr['no_data']=6;
	$xmlrpcstr['no_data']='No data received from server.';
	$xmlrpcerr['no_ssl']=7;
	$xmlrpcstr['no_ssl']='No SSL support compiled in.';
	$xmlrpcerr['curl_fail']=8;
	$xmlrpcstr['curl_fail']='CURL error';
	$xmlrpcerr['no_curl']=15;
	$xmlrpcstr['no_curl']='No CURL support compiled in.';
	$xmlrpcerr['server_error']=16;
	$xmlrpcstr['server_error']='Internal server error';

	$xmlrpcerr['multicall_notstruct'] = 9;
	$xmlrpcstr['multicall_notstruct'] = 'system.multicall expected struct';
	$xmlrpcerr['multicall_nomethod']  = 10;
	$xmlrpcstr['multicall_nomethod']  = 'missing methodName';
	$xmlrpcerr['multicall_notstring'] = 11;
	$xmlrpcstr['multicall_notstring'] = 'methodName is not a string';
	$xmlrpcerr['multicall_recursion'] = 12;
	$xmlrpcstr['multicall_recursion'] = 'recursive system.multicall forbidden';
	$xmlrpcerr['multicall_noparams']  = 13;
	$xmlrpcstr['multicall_noparams']  = 'missing params';
	$xmlrpcerr['multicall_notarray']  = 14;
	$xmlrpcstr['multicall_notarray']  = 'params is not an array';

	$xmlrpcerr['cannot_decompress']=103;
	$xmlrpcstr['cannot_decompress']='Received from server compressed HTTP and cannot decompress';
	$xmlrpcerr['decompress_fail']=104;
	$xmlrpcstr['decompress_fail']='Received from server invalid compressed HTTP';
	$xmlrpcerr['dechunk_fail']=105;
	$xmlrpcstr['dechunk_fail']='Received from server invalid chunked HTTP';
	$xmlrpcerr['server_cannot_decompress']=106;
	$xmlrpcstr['server_cannot_decompress']='Received from client compressed HTTP request and cannot decompress';
	$xmlrpcerr['server_decompress_fail']=107;
	$xmlrpcstr['server_decompress_fail']='Received from client invalid compressed HTTP request';

	// The charset encoding expected by the server for received messages and
	// by the client for received responses
	$xmlrpc_defencoding='UTF-8';
	// The encoding used by PHP.
	// String values received will be converted to this.
	$xmlrpc_internalencoding='ISO-8859-1';

	$xmlrpcName='XML-RPC for PHP';
	$xmlrpcVersion='2.0 beta';

	// let user errors start at 800
	$xmlrpcerruser=800;
	// let XML parse errors start at 100
	$xmlrpcerrxml=100;

	// formulate backslashes for escaping regexp
	$xmlrpc_backslash=chr(92).chr(92);

	// used to store state during parsing
	// quick explanation of components:
	//   st - used to build up a string for evaluation
	//   ac - used to accumulate values
	//   qt - used to decide if quotes are needed for evaluation
	//   cm - used to denote struct or array (comma needed)
	//   isf - used to indicate a fault
	//   lv - used to indicate "looking for a value": implements
	//        the logic to allow values with no types to be strings
	//   params - used to store parameters in method calls
	//   method - used to store method name

	$_xh=null;


	/**
	* To help correct communication of non-ascii chars inside strings, regardless
	* of the charset used when sending requests, parsing them, sending responses
	* and parsing responses, convert all non-ascii chars present in the message
	* into their equivalent 'charset entity'. Charset entities enumerated this way
	* are independent of the charset encoding used to transmit them, and all XML
	* parsers are bound to understand them.
	*/
	function xmlrpc_encode_entitites($data)
	{
		$length = strlen($data);
		$escapeddata = "";
		for($position = 0; $position < $length; $position++)
		{
			$character = substr($data, $position, 1);
			$code = Ord($character);
			switch($code) {
				case 34:
				$character = "&quot;";
				break;
				case 38:
				$character = "&amp;";
				break;
				case 39:
				$character = "&apos;";
				break;
				case 60:
				$character = "&lt;";
				break;
				case 62:
				$character = "&gt;";
				break;
				default:
				if ($code < 32 || $code > 159)
					$character = ("&#".strval($code).";");
				break;
			}
			$escapeddata .= $character;
		}
		return $escapeddata;
	}

	function xmlrpc_se($parser, $name, $attrs)
	{
		global $_xh, $xmlrpcDateTime, $xmlrpcString;

		switch($name)
		{
			case 'STRUCT':
			case 'ARRAY':
				$_xh['st'].='array(';
				$_xh['cm']++;
				// this last line turns quoting off
				// this means if we get an empty array we'll
				// simply get a bit of whitespace in the eval
				$_xh['qt']=0;
				break;
			case 'NAME':
				$_xh['st'].='"';
				$_xh['ac']='';
				break;
			case 'FAULT':
				$_xh['isf']=1;
				break;
			case 'PARAM':
				$_xh['st']='';
				break;
			case 'VALUE':
				$_xh['st'].='new xmlrpcval(';
				$_xh['vt']=$xmlrpcString;
				$_xh['ac']='';
				$_xh['qt']=0;
				$_xh['lv']=1;
				// look for a value: if this is still 1 by the
				// time we reach the first data segment then the type is string
				// by implication and we need to add in a quote
				break;
			case 'I4':
			case 'INT':
			case 'STRING':
			case 'BOOLEAN':
			case 'DOUBLE':
			case 'DATETIME.ISO8601':
			case 'BASE64':
				$_xh['ac']=''; // reset the accumulator

				if ($name=='DATETIME.ISO8601' || $name=='STRING')
				{
					$_xh['qt']=1;
					if ($name=='DATETIME.ISO8601')
					{
						$_xh['vt']=$xmlrpcDateTime;
					}
				}
				elseif ($name=='BASE64')
				{
					$_xh['qt']=2;
				}
				else
				{
					// No quoting is required here -- but
					// at the end of the element we must check
					// for data format errors.
					$_xh['qt']=0;
				}
				break;
			case 'MEMBER':
				$_xh['ac']='';
				break;
			default:
				break;
		}

		if ($name!='VALUE')
		{
			$_xh['lv']=0;
		}
	}

	function xmlrpc_ee($parser, $name)
	{
		global $_xh,$xmlrpcTypes,$xmlrpcString;

		switch($name)
		{
			case 'STRUCT':
			case 'ARRAY':
				if ($_xh['cm'] && substr($_xh['st'], -1) ==',')
				{
					$_xh['st']=substr($_xh['st'],0,-1);
				}
				$_xh['st'].=')';
				$_xh['vt']=strtolower($name);
				$_xh['cm']--;
				break;
			case 'NAME':
				$_xh['st'].= $_xh['ac'] . '" => ';
				break;
			case 'BOOLEAN':
				// special case here: we translate boolean 1 or 0 into PHP
				// constants true or false
				if ($_xh['ac']=='1')
				{
					$_xh['ac']='true';
				}
				else
				{
					$_xh['ac']='false';
				}
				$_xh['vt']=strtolower($name);
				// Drop through intentionally.
			case 'I4':
			case 'INT':
			case 'STRING':
			case 'DOUBLE':
			case 'DATETIME.ISO8601':
			case 'BASE64':
				if ($_xh['qt']==1)
				{
					// we use double quotes rather than single so backslashification works OK
					$_xh['st'].='"'. $_xh['ac'] . '"';
				}
				elseif ($_xh['qt']==2)
				{
					$_xh['st'].='base64_decode("'. $_xh['ac'] . '")';
				}
				elseif ($name=='BOOLEAN')
				{
					$_xh['st'].=$_xh['ac'];
				}
				elseif ($name=='DOUBLE')
				{
					// we have a DOUBLE
					// we must check that only 0123456789-.<space> are characters here
					if (!ereg("^[+-]?[eE0123456789 \\t\\.]+$", $_xh['ac']))
					{
						// TODO: find a better way of throwing an error
						// than this!
						error_log('XML-RPC: non numeric value received in DOUBLE: '.$_xh['ac']);
						$_xh['st'].="'ERROR_NON_NUMERIC_FOUND'";
					}
					else
					{
						// it's ok, add it on
						$_xh['st'].=(double)$_xh['ac'];
					}
				}
				else
				{
					// we have an I4/INT
					// we must check that only 0123456789-<space> are characters here
					if (!ereg("^[+-]?[0123456789 \\t]+$", $_xh['ac']))
					{
						// TODO: find a better way of throwing an error
						// than this!
						error_log('XML-RPC: non numeric value received in INT: '.$_xh['ac']);
						$_xh['st'].="'ERROR_NON_NUMERIC_FOUND'";
					}
					else
					{
						// it's ok, add it on
						$_xh['st'].=(int)$_xh['ac'];
					}
				}
				$_xh['ac']='';
				$_xh['qt']=0;
				$_xh['lv']=3; // indicate we've found a value
				break;
			case 'VALUE':
				// deal with a string value
				if (strlen($_xh['ac'])>0 &&
					$_xh['vt']==$xmlrpcString)
				{
					$_xh['st'].='"'. $_xh['ac'] . '"';
				}
				// This if() detects if no scalar was inside <VALUE></VALUE>
				// and pads an empty ''.
				if($_xh['st'][strlen($_xh['st'])-1] == '(')
				{
					$_xh['st'].= '""';
				}
				// G. Giunta 2005/03/12 save some chars in the reconstruction of string vals...
				if ($_xh['vt'] != $xmlrpcString)
					$_xh['st'].=", '" . $_xh['vt'] . "')";
				else
					$_xh['st'].=")";
				if ($_xh['cm'])
				{
					$_xh['st'].=',';
				}
				break;
			case 'MEMBER':
				$_xh['ac']='';
				$_xh['qt']=0;
				break;
			case 'DATA':
				$_xh['ac']='';
				$_xh['qt']=0;
				break;
			case 'PARAM':
				$_xh['params'][]=$_xh['st'];
				break;
			case 'METHODNAME':
				$_xh['method']=ereg_replace("^[\n\r\t ]+", '', $_xh['ac']);
				break;
			// BOOLEAN HAS BEEN ENUMERATED ABOVE!
			/*case 'BOOLEAN':
				// special case here: we translate boolean 1 or 0 into PHP
				// constants true or false
				if ($_xh['ac']=='1')
				{
					$_xh['ac']='true';
				}
				else
				{
					$_xh['ac']='false';
					$_xh['vt']=strtolower($name);
				}
				break;*/
			default:
				break;
		}
		// if it's a valid type name, set the type
		if (isset($xmlrpcTypes[strtolower($name)]))
		{
			$_xh['vt']=strtolower($name);
		}
	}

	function xmlrpc_cd($parser, $data)
	{
		global $_xh, $xmlrpc_backslash;

		//if (ereg("^[\n\r \t]+$", $data)) return;
		// print "adding [${data}]\n";

		if ($_xh['lv']!=3)
		{
			// "lookforvalue==3" means that we've found an entire value
			// and should discard any further character data
			if ($_xh['lv']==1)
			{
				// if we've found text and we're just in a <value> then
				// turn quoting on, as this will be a string
				$_xh['qt']=1;
				// and say we've found a value
				$_xh['lv']=2;
			}
			if(!@isset($_xh['ac']))
			{
				$_xh['ac'] = '';
			}
			$_xh['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
		}
	}

	function xmlrpc_dh($parser, $data)
	{
		global $_xh, $xmlrpc_backslash;
		if (substr($data, 0, 1) == '&' && substr($data, -1, 1) == ';')
		{
			if ($_xh['lv']==1)
			{
				$_xh['qt']=1;
				$_xh['lv']=2;
			}
			$_xh['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
		}
	}

	class xmlrpc_client
	{
		var $path;
		var $server;
		var $port;
		var $errno;
		var $errstr;
		var $debug=0;
		var $username='';
		var $password='';
		var $cert='';
		var $certpass='';
		var $verifypeer=1;
		var $verifyhost=1;
		var $no_multicall=false;
		var $proxy = '';
		var $proxyport=0;
		var $proxy_user = '';
		var $proxy_pass = '';
		/**
		* List of http compression methods accepted by the client for responses.
		* NB: PHP supports deflate, gzip compressions out of the box if compiled w. zlib
		*/
		var $accepted_compression = array();
		/**
		* Name of compression scheme to be used for sending requests.
		* Either null, gzip or deflate
		*/
		var $request_compression = '';

		function xmlrpc_client($path, $server, $port=0)
		{
			$this->port=$port; $this->server=$server; $this->path=$path;
			// if ZLIB is enabled, let the server by default accept compressed requests
			if (function_exists('gzinflate'))
				$this->accepted_compression = array('gzip', 'deflate');
		}

		function setDebug($in)
		{
			if ($in)
			{
				$this->debug=1;
			}
			else
			{
				$this->debug=0;
			}
		}

		function setCredentials($u, $p)
		{
			$this->username=$u;
			$this->password=$p;
		}

		function setCertificate($cert, $certpass)
		{
			$this->cert = $cert;
			$this->certpass = $certpass;
		}

		function setSSLVerifyPeer($i)
		{
			$this->verifypeer = $i;
		}

		function setSSLVerifyHost($i)
		{
			$this->verifyhost = $i;
		}

		/**
		* set proxy info
		*
		* @param    string $proxyhost
		* @param    string $proxyport. Defaults to 8080 for HTTP and 443 for HTTPS
		* @param	string $proxyusername
		* @param	string $proxypassword
		* @access   public
		*/
		function setProxy($proxyhost, $proxyport, $proxyusername = '', $proxypassword = '') {
			$this->proxy = $proxyhost;
			$this->proxyport = $proxyport;
			$this->proxy_user = $proxyusername;
			$this->proxy_pass = $proxypassword;
		}

		function send($msg, $timeout=0, $method='http')
		{
			if (is_array($msg))
			{
				// $msg is an array of xmlrpcmsg's
				return $this->multicall($msg, $timeout, $method);
			}

			// where msg is an xmlrpcmsg
			$msg->debug=$this->debug;

			if ($method == 'https')
			{
				return $this->sendPayloadHTTPS($msg,
				$this->server,
				$this->port, $timeout,
				$this->username, $this->password,
				$this->cert,
				$this->certpass,
				$this->proxy,
				$this->proxyport,
				$this->proxy_user,
				$this->proxy_pass);
			}
			else
			if ($method == 'http11')
			{
				return $this->sendPayloadCURL($msg,
				$this->server,
				$this->port, $timeout,
				$this->username, $this->password,
				null,
				null,
				$this->proxy,
				$this->proxyport,
				$this->proxy_user,
				$this->proxy_pass, 'http');
			}
			else
			{
				return $this->sendPayloadHTTP10($msg, $this->server, $this->port,
				$timeout, $this->username,
				$this->password,
				$this->proxy,
				$this->proxyport,
				$this->proxy_user,
				$this->proxy_pass);
			}
		}

		function sendPayloadHTTP10($msg, $server, $port, $timeout=0,$username='', $password='',
			$proxyhost='', $proxyport=0, $proxyusername='', $proxypassword='')
		{
			global $xmlrpcerr, $xmlrpcstr, $xmlrpcName, $xmlrpcVersion, $xmlrpc_defencoding;
			if ($port==0)
			{
				$port=80;
			}

			// Only create the payload if it was not created previously
			if(empty($msg->payload))
			{
				$msg->createPayload();
			}

			// thanks to Grant Rauscher <grant7@firstworld.net>
			// for this
			$credentials='';
			if ($username!='')
			{
				$credentials='Authorization: Basic ' . base64_encode($username . ':' . $password) . "\r\n";
			}

			$accepted_encoding = '';
			if (count($this->accepted_compression))
			{
				$accepted_encoding = 'Accept-Encoding: ' . implode(',', $this->accepted_compression) . "\r\n";
			}

			$proxy_credentials = '';
			if ($proxyhost)
			{
				if ($proxyport == 0)
					$proxyport = 8080;
				$connectserver = $proxyhost;
				$connectport = $proxyport;
				$uri = 'http://'.$server.':'.$port.$this->path;
				if ($proxyusername != '')
				{
					$proxy_credentials = 'Proxy-Authorization: Basic ' . base64_encode($proxyusername.':'.$proxypassword) . "\r\n";
				}
			}
			else
			{
				$connectserver = $server;
				$connectport = $port;
				$uri = $this->path;
			}

			$op= "POST " . $uri. " HTTP/1.0\r\n" .
				"User-Agent: " . $xmlrpcName . " " . $xmlrpcVersion . "\r\n" .
				"Host: ". $server . "\r\n" .
				$credentials .
				$proxy_credentials .
				$accepted_encoding .
				"Accept-Charset: " . $xmlrpc_defencoding . "\r\n" .
				"Content-Type: text/xml\r\nContent-Length: " .
				strlen($msg->payload) . "\r\n\r\n" .
				$msg->payload;

			if($timeout>0)
			{
				$fp=@fsockopen($connectserver, $connectport, $this->errno, $this->errstr, $timeout);
			}
			else
			{
				$fp=@fsockopen($connectserver, $connectport, $this->errno, $this->errstr);
			}
			if ($fp)
			{
				if ($timeout>0 && function_exists('stream_set_timeout'))
					stream_set_timeout($fp, $timeout);
			}
			else
			{
				$this->errstr='Connect error: '.$this->errstr;
				$r=&new xmlrpcresp(0, $xmlrpcerr['http_error'], $this->errstr . ' (' . $this->errno . ')');
				return $r;
			}

			if (!fputs($fp, $op, strlen($op)))
			{
				$this->errstr='Write error';
				$r=&new xmlrpcresp(0, $xmlrpcerr['http_error'], $this->errstr);
				return $r;
			}
			else
			{
				// should we reset errno and errstr on succesful socket connection?
			}
			$resp=&$msg->parseResponseFile($fp);
			fclose($fp);
			return $resp;
		}

		// contributed by Justin Miller <justin@voxel.net>
		// requires curl to be built into PHP
		// NB: CURL versions before 7.11.10 cannot use proxy to talk to https servers!
		function sendPayloadHTTPS($msg, $server, $port, $timeout=0,$username='', $password='', $cert='',$certpass='',
			$proxyhost='', $proxyport=0, $proxyusername='', $proxypassword='')
		{
			return $this->sendPayloadCURL($msg, $server, $port, $timeout, $username, $password, $cert, $certpass,
				$proxyhost, $proxyport, $proxyusername, $proxypassword);
		}

		function sendPayloadCURL($msg, $server, $port, $timeout=0, $username='', $password='', $cert='', $certpass='',
			$proxyhost='', $proxyport=0, $proxyusername='', $proxypassword='', $method='https')
		{
			global $xmlrpcerr, $xmlrpcstr, $xmlrpcName, $xmlrpcVersion, $xmlrpc_internalencoding;
			if ($port == 0)
			{
				if ($method == 'http')
				{
					$port = 80;
				}
				else
				{
					$port = 443;
				}
			}

			// Only create the payload if it was not created previously
			if(empty($msg->payload))
			{
				$msg->createPayload();
			}

			if (!function_exists('curl_init'))
			{
				if ($method == 'http')
				{
					$this->errstr='CURL unavailable on this install';
					$r=&new xmlrpcresp(0, $xmlrpcerr['no_curl'], $xmlrpcstr['no_curl']);
				}
                else
				{
					$this->errstr='SSL unavailable on this install';
					$r=&new xmlrpcresp(0, $xmlrpcerr['no_ssl'], $xmlrpcstr['no_ssl']);
				}
				return $r;
			}

			$curl = curl_init($method . '://' . $server . ':' . $port . $this->path);

			// results into variable
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

			if ($this->debug)
			{
				curl_setopt($curl, CURLOPT_VERBOSE, 1);
			}
			curl_setopt($curl, CURLOPT_USERAGENT, $xmlrpcName.' '.$xmlrpcVersion);
			// required for XMLRPC: post the data
			curl_setopt($curl, CURLOPT_POST, 1);
			// the data
			curl_setopt($curl, CURLOPT_POSTFIELDS, $msg->payload);

			// 2005/05/10: do not return HTTP headers anymore when using curls, since
			// parseresponse will use any http headers it finds to do more HTTP tricks
			//curl_setopt($curl, CURLOPT_HEADER, 1);
			// return the header too

			// will only work with PHP >= 5.0
            // NB: if we set an empty string, CURL will add http header indicating
            // ALL methods it is supporting. This is possibly a better option than
            // letting the user tell what curl can / cannot do...
			if (count($this->accepted_compression))
			{
				curl_setopt($curl, CURLOPT_ENCODING, implode(',', $this->accepted_compression));
				//curl_setopt($curl, CURLOPT_ENCODING, '');
			}			
			// required for XMLRPC
			curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: text/xml', 'Accept-Charset: '.$xmlrpc_internalencoding));
			// timeout is borked
			if ($timeout)
			{
				curl_setopt($curl, CURLOPT_TIMEOUT, $timeout == 1 ? 1 : $timeout - 1);
			}

			if ($username && $password)
			{
				curl_setopt($curl, CURLOPT_USERPWD,"$username:$password");
			}

			if ($method == 'https')
			{
				// set cert file
				if ($cert)
				{
					curl_setopt($curl, CURLOPT_SSLCERT, $cert);
				}
				// set cert password
				if ($certpass)
				{
					curl_setopt($curl, CURLOPT_SSLCERTPASSWD, $certpass);
				}
				// whether to verify remote host's cert
				curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $this->verifypeer);
				// whether to verify cert's common name (CN); 0 for no, 1 to verify that it exists, and 2 to verify that it matches the hostname used
				curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, $this->verifyhost);
			}

			// proxy info
			if ($proxyhost)
			{
				if ($proxyport == 0)
					$proxyport = 8080; // NB: even for HTTPS, local connection is on port 8080
				curl_setopt($curl, CURLOPT_PROXY,$proxyhost.':'.$proxyport);
				//curl_setopt($curl, CURLOPT_PROXYPORT,$proxyport);
				if ($proxyusername)
					curl_setopt($curl, CURLOPT_PROXYUSERPWD, $proxyusername.':'.$proxypassword);
			}

			$result = curl_exec($curl);

			if (!$result)
			{
				$this->errstr='no response';
				$resp=&new xmlrpcresp(0, $xmlrpcerr['curl_fail'], $xmlrpcstr['curl_fail']. ': '. curl_error($curl));
				curl_close($curl);
			}
			else
			{
				curl_close($curl);
				$resp =& $msg->parseResponse($result);
			}
			return $resp;
		}

		function multicall($msgs, $timeout=0, $method='http')
		{
			$results = false;

			if (! $this->no_multicall)
			{
				$results = $this->_try_multicall($msgs, $timeout, $method);
				/* TODO - this is not php3-friendly */
				// if($results !== false)
				if(is_array($results))
				{
					// Either the system.multicall succeeded, or the send
					// failed (e.g. due to HTTP timeout). In either case,
					// we're done for now.
					return $results;
				}
				else
				{
					// system.multicall unsupported by server,
					// don't try it next time...
					$this->no_multicall = true;
				}
			}

			// system.multicall is unupported by server:
			//   Emulate multicall via multiple requests
			$results = array();
			//@reset($msgs);
			//while(list(,$msg) = @each($msgs))
			foreach($msgs as $msg)
			{
				$results[] = $this->send($msg, $timeout, $method);
			}
			return $results;
		}

		// Attempt to boxcar $msgs via system.multicall.
		function _try_multicall($msgs, $timeout, $method)
		{
			// Construct multicall message
			$calls = array();
			//@reset($msgs);
			//while(list(,$msg) = @each($msgs))
			foreach($msgs as $msg)
			{
				$call['methodName'] =& new xmlrpcval($msg->method(),'string');
				$numParams = $msg->getNumParams();
				$params = array();
				for ($i = 0; $i < $numParams; $i++)
				{
					$params[$i] = $msg->getParam($i);
				}
				$call['params'] =& new xmlrpcval($params, 'array');
				$calls[] =& new xmlrpcval($call, 'struct');
			}
			$multicall =& new xmlrpcmsg('system.multicall');
			$multicall->addParam(new xmlrpcval($calls, 'array'));

			// Attempt RPC call
			$result =& $this->send($multicall, $timeout, $method);
			//if(!is_object($result))
			//{
			//	return ($result || 0); // transport failed
			//}

			if($result->faultCode() != 0)
			{
				return false;		// system.multicall failed
			}

			// Unpack responses.
			$rets = $result->value();
			if($rets->kindOf() != 'array')
			{
				return false;		// bad return type from system.multicall
			}
			$numRets = $rets->arraysize();
			if($numRets != count($msgs))
			{
				return false;		// wrong number of return values.
			}

			$response = array();
			for ($i = 0; $i < $numRets; $i++)
			{
				$val = $rets->arraymem($i);
				switch ($val->kindOf())
				{
				case 'array':
					if($val->arraysize() != 1)
					{
						return false;		// Bad value
					}
					// Normal return value
					$response[$i] =& new xmlrpcresp($val->arraymem(0));
					break;
				case 'struct':
					$code = $val->structmem('faultCode');
					if($code->kindOf() != 'scalar' || $code->scalartyp() != 'int')
					{
						return false;
					}
					$str = $val->structmem('faultString');
					if($str->kindOf() != 'scalar' || $str->scalartyp() != 'string')
					{
						return false;
					}
					$response[$i] =& new xmlrpcresp(0, $code->scalarval(), $str->scalarval());
					break;
				default:
					return false;
				}
			}
			return $response;
		}
	} // end class xmlrpc_client

	class xmlrpcresp
	{
		var $val = 0;
		var $errno = 0;
		var $errstr = '';
		var $hdrs = array();

		function xmlrpcresp($val, $fcode = 0, $fstr = '')
		{
			if ($fcode != 0)
			{
				// error
				$this->errno = $fcode;
				$this->errstr = $fstr;
				//$this->errstr = htmlspecialchars($fstr); // XXX: encoding probably shouldn't be done here; fix later.
			}
			elseif (!is_object($val))
			{
				// programmer error
				error_log("Invalid type '" . gettype($val) . "' (value: $val) passed to xmlrpcresp. Defaulting to empty value.");
				$this->val =& new xmlrpcval();
			}
			else
			{
				// success
				$this->val = $val;
			}
		}

		function faultCode()
		{
			return $this->errno;
		}

		function faultString()
		{
			return $this->errstr;
		}

		function value()
		{
			return $this->val;
		}

		function serialize()
		{
			$result = "<methodResponse>\n";
			if ($this->errno)
			{
				// G. Giunta 2005/2/13: let non-ASCII response messages be tolerated by clients
				$result .= '<fault>
<value>
<struct>
<member>
<name>faultCode</name>
<value><int>' . $this->errno . '</int></value>
</member>
<member>
<name>faultString</name>
<value><string>' . xmlrpc_encode_entitites($this->errstr) . '</string></value>
</member>
</struct>
</value>
</fault>';
			}
			else
			{
				$result .= "<params>\n<param>\n" .
					$this->val->serialize() .
					"</param>\n</params>";
			}
			$result .= "\n</methodResponse>";
			return $result;
		}
	}

	class xmlrpcmsg
	{
		var $payload;
		var $methodname;
		var $params=array();
		var $debug=0;

		function xmlrpcmsg($meth, $pars=0)
		{
			$this->methodname=$meth;
			if (is_array($pars) && sizeof($pars)>0)
			{
				for($i=0; $i<sizeof($pars); $i++)
				{
					$this->addParam($pars[$i]);
				}
			}
		}

		function xml_header()
		{
			return "<?xml version=\"1.0\"?" . ">\n<methodCall>\n";
		}

		function xml_footer()
		{
			return "</methodCall>\n";
		}

		function createPayload()
		{
			$this->payload=$this->xml_header();
			$this->payload.='<methodName>' . $this->methodname . "</methodName>\n";
			//	if (sizeof($this->params)) {
			$this->payload.="<params>\n";
			for($i=0; $i<sizeof($this->params); $i++)
			{
				$p=$this->params[$i];
				$this->payload.="<param>\n" . $p->serialize() .
				"</param>\n";
			}
			$this->payload.="</params>\n";
			// }
			$this->payload.=$this->xml_footer();
			//$this->payload=str_replace("\n", "\r\n", $this->payload);
		}

		function method($meth='')
		{
			if ($meth!='')
			{
				$this->methodname=$meth;
			}
			return $this->methodname;
		}

		function serialize()
		{
			$this->createPayload();
			return $this->payload;
		}

		function addParam($par) { $this->params[]=$par; }
		function getParam($i) { return $this->params[$i]; }
		function getNumParams() { return sizeof($this->params); }

		function parseResponseFile($fp)
		{
			$ipd='';
			while($data=fread($fp, 32768))
			{
				$ipd.=$data;
			}
			return $this->parseResponse($ipd);
		}

		function parseResponse($data='')
		{
			global $_xh,$xmlrpcerr,$xmlrpcstr;
			global $xmlrpc_defencoding, $xmlrpc_internalencoding;

			$hdrfnd = 0;
			if($this->debug)
			{
				//by maHo, replaced htmlspecialchars with htmlentities
				print "<PRE>---GOT---\n" . htmlentities($data) . "\n---END---\n</PRE>";
			}

			if($data == '')
			{
				error_log('No response received from server.');
				$r =& new xmlrpcresp(0, $xmlrpcerr['no_data'], $xmlrpcstr['no_data']);
				return $r;
			}
			// see if we got an HTTP 200 OK, else bomb
			// but only do this if we're using the HTTP protocol.
			if(ereg("^HTTP",$data))
			{
				// Strip HTTP 1.1 100 Continue header if present
				while (ereg('^HTTP/1.1 1[0-9]{2} ', $data))
				{
					$pos = strpos($data, 'HTTP', 12);
					// server sent a Continue header without any (valid) content following...
					// give the client a chance to know it
					if (!$pos && !is_int($pos)) // works fine in php 3, 4 and 5
					  break;
					$data = substr($data, $pos);
				}
				if (!ereg("^HTTP/[0-9\\.]+ 200 ", $data))
				{
					$errstr= substr($data, 0, strpos($data, "\n")-1);
					error_log('HTTP error, got response: ' .$errstr);
					$r=&new xmlrpcresp(0, $xmlrpcerr['http_error'], $xmlrpcstr['http_error']. ' (' . $errstr . ')');
					return $r;
				}
			}

			$_xh=array();
			$_xh['headers'] = array();

			// separate HTTP headers from data
			if (ereg("^HTTP", $data))
			{
				// be tolerant to usage of \n instead of \r\n to separate headers and data
				// (even though it is not valid http)
				$pos = strpos($data,"\r\n\r\n");
				if($pos || is_int($pos))
					$bd = $pos+4;
				else
				{
					$pos = strpos($data,"\n\n");
					if($pos || is_int($pos))
						$bd = $pos+2;
					else
					{
						// No separation between response headers and body: fault?
						$bd = 0;
					}
				}
				// be tolerant to line endings, and extra empty lines
				$ar = split("\r?\n", trim(substr($data, 0, $pos)));
				while (list(,$line) = @each($ar))
				{
					// take care of multi-line headers
					$arr = explode(':',$line);
					if(count($arr) > 1)
					{
						$header_name = strtolower(trim($arr[0]));
						// TO DO: some headers (the ones that allow a CSV list of values)
						// do allow many values to be passed using multiple header lines.
						// We should add content to $_xh['headers'][$header_name]
						// instead of replacing it for those...
						$_xh['headers'][$header_name] = $arr[1];
						for ($i = 2; $i < count($arr); $i++)
						{
							$_xh['headers'][$header_name] .= ':'.$arr[$i];
						} // while
						$_xh['headers'][$header_name] = trim($_xh['headers'][$header_name]);
					} else if (isset($header_name))
					{
						$_xh['headers'][$header_name] .= ' ' . trim($line);
					}
				}
				$data = substr($data, $bd);

				if ($this->debug && count($_xh['headers']))
				{
					print '<PRE>';
					//@reset($_xh['headers']);
					//while(list($header, $value) = @each($_xh['headers']))
					foreach ($_xh['headers'] as $header => $value)
					{
						print "HEADER: $header: $value\n";
					}
					print "</PRE>\n";
				}
			}

			// Decode chunked encoding sent by http 1.1 servers
			if(isset($_xh['headers']['transfer-encoding']) && $_xh['headers']['transfer-encoding'] == 'chunked')
			{
				if(!$data = decode_chunked($data))
				{
					error_log('Errors occurred when trying to rebuild the chunked data received from server');
					$r =& new xmlrpcresp(0, $xmlrpcerr['dechunk_fail'], $xmlrpcstr['dechunk_fail']);
					return $r;
				}
			}

			// Decode gzip-compressed stuff
			// code shamelessly inspired from nusoap library by Dietrich Ayala
			if(isset($_xh['headers']['content-encoding']))
			{
				if($_xh['headers']['content-encoding'] == 'deflate' || $_xh['headers']['content-encoding'] == 'gzip')
				{
				// if decoding works, use it. else assume data wasn't gzencoded
				if(function_exists('gzinflate'))
				{
					if($_xh['headers']['content-encoding'] == 'deflate' && $degzdata = @gzinflate($data))
					{
						$data = $degzdata;
						if($this->debug)
							print "<PRE>---INFLATED RESPONSE---[".strlen($data)." chars]---\n" . htmlentities($data) . "\n---END---</PRE>";
					}
					elseif($_xh['headers']['content-encoding'] == 'gzip' && $degzdata = @gzinflate(substr($data, 10)))
					{
						$data = $degzdata;
						if($this->debug)
							print "<PRE>---INFLATED RESPONSE---[".strlen($data)." chars]---\n" . htmlentities($data) . "\n---END---</PRE>";
					}
					else
					{
						error_log('Errors occurred when trying to decode the deflated data received from server');
						$r =& new xmlrpcresp(0, $xmlrpcerr['decompress_fail'], $xmlrpcstr['decompress_fail']);
						return $r;
					}
				}
				else
				{
					error_log('The server sent deflated data. Your php install must have the Zlib extension compiled in to support this.');
					$r =& new xmlrpcresp(0, $xmlrpcerr['cannot_decompress'], $xmlrpcstr['cannot_decompress']);
					return $r;
				}
				}
			}

			// be tolerant of extra whitespace in response body
			$data = trim($data);

			// be tolerant of junk after methodResponse (e.g. javascript automatically inserted by free hosts)
			// idea from Luca Mariano <luca.mariano@email.it> originally in PEARified version of the lib
			$bd = false;
			$pos = strpos($data, "</methodResponse>");
			while ($pos || is_int($pos))
			{
				$bd = $pos+17;
				$pos = strpos($data, "</methodResponse>", $bd);
			}
			if ($bd)
				$data = substr($data, 0, $bd);

			$_xh['st']='';
			$_xh['cm']=0;
			$_xh['isf']=0;
			$_xh['ac']='';
			$_xh['qt']='';

			$parser = xml_parser_create($xmlrpc_defencoding);
			xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, true);
			// G. Giunta 2005/02/13: PHP internally uses ISO-8859-1, so we have to tell
			// the xml parser to give us back data in the expected charset
			xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, $xmlrpc_internalencoding);

			xml_set_element_handler($parser, 'xmlrpc_se', 'xmlrpc_ee');
			xml_set_character_data_handler($parser, 'xmlrpc_cd');
			xml_set_default_handler($parser, 'xmlrpc_dh');
			//$xmlrpc_value=new xmlrpcval;

			if (!xml_parse($parser, $data, sizeof($data)))
			{
				// thanks to Peter Kocks <peter.kocks@baygate.com>
				if((xml_get_current_line_number($parser)) == 1)
				{
					$errstr = 'XML error at line 1, check URL';
				}
				else
				{
					$errstr = sprintf('XML error: %s at line %d',
						xml_error_string(xml_get_error_code($parser)),
						xml_get_current_line_number($parser));
				}
				error_log($errstr);
				$r=&new xmlrpcresp(0, $xmlrpcerr['invalid_return'], $xmlrpcstr['invalid_return'].' ('.$errstr.')');
				xml_parser_free($parser);
				if ($this->debug)
					print $errstr;
				$r->hdrs = $_xh['headers'];
				return $r;
			}
			xml_parser_free($parser);
			if ($this->debug)
			{
				print "<PRE>---EVALING---[" .
				strlen($_xh['st']) . " chars]---\n" .
				htmlspecialchars($_xh['st']) . ";\n---END---</PRE>";
			}
			if (strlen($_xh['st'])==0)
			{
				// then something odd has happened
				// and it's time to generate a client side error
				// indicating something odd went on
				$r=&new xmlrpcresp(0, $xmlrpcerr['invalid_return'],
				$xmlrpcstr['invalid_return']);
			}
			else
			{
				$allOK = @eval('$v=&' . $_xh['st'] . ';');
				if ($allOK === false)
				{
					$r = new xmlrpcresp(0, $xmlrpcerr['invalid_return'], $xmlrpcstr['invalid_return']);
				}
				if ($_xh['isf'])
				{
					$errno_v = $v->structmem('faultCode');
					$errstr_v = $v->structmem('faultString');
					$errno = $errno_v->scalarval();

					if ($errno == 0)
					{
						// FAULT returned, errno needs to reflect that
						$errno = -1;
					}

					$r =& new xmlrpcresp($v, $errno, $errstr_v->scalarval());
				}
				else
				{
					$r=&new xmlrpcresp($v);
				}
			}

			$r->hdrs = $_xh['headers'];
			return $r;
		}
	}

	class xmlrpcval
	{
		var $me=array();
		var $mytype=0;

		function xmlrpcval($val=-1, $type='')
		{
			global $xmlrpcTypes;
			//$this->me=array();
			//$this->mytype=0;
			if ($val!==-1 || $type!='')
			{
				if ($type=='')
				{
					$type='string';
				}
				if ($xmlrpcTypes[$type]==1)
				{
					$this->addScalar($val,$type);
				}
				elseif ($xmlrpcTypes[$type]==2)
				{
					$this->addArray($val);
				}
				elseif ($xmlrpcTypes[$type]==3)
				{
					$this->addStruct($val);
				}
			}
		}

		function addScalar($val, $type='string')
		{
			global $xmlrpcTypes, $xmlrpcBoolean;

			$typeof=@$xmlrpcTypes[$type];
			if ($typeof!=1)
			{
				error_log("addScalar: not a scalar type ($typeof)");
				return 0;
			}

			// coerce booleans into correct values
			// NB: shall we do it for datetime too?
			if ($type==$xmlrpcBoolean)
			{
				if (strcasecmp($val,'true')==0 || $val==1 || ($val==true && strcasecmp($val,'false')))
				{
					$val=true;
				}
				else
				{
					$val=false;
				}
			}

			switch ($this->mytype)
			{
				case 1:
					error_log('addScalar: scalar xmlrpcval can have only one value');
					return 0;
				case 3:
					error_log('addScalar: cannot add anonymous scalar to struct xmlrpcval');
					return 0;
				case 2:
					// we're adding a scalar value to an array here
					//$ar=$this->me['array'];
					//$ar[]=&new xmlrpcval($val, $type);
					//$this->me['array']=$ar;
	                // Faster (?) avoid all the costly array-copy-by-val done here...
    	            $this->me['array'][]=&new xmlrpcval($val, $type);
					return 1;
				default:
					// a scalar, so set the value and remember we're scalar
					$this->me[$type]=$val;
					$this->mytype=$typeof;
					return 1;
			}
		}

		///@todo add some checking for $vals to be an array?
		function addArray($vals)
		{
			global $xmlrpcTypes;
			if ($this->mytype==0)
			{
				$this->mytype=$xmlrpcTypes['array'];
				$this->me['array']=$vals;
				return 1;
			}
			elseif ($this->mytype==2)
			{
				// we're adding to an array here
				$this->me['array'] = array_merge($this->me['array'], $vals);
			}
			else
			{
				error_log('xmlrpcval: already initialized as a [' . $this->kindOf() . ']');
				return 0;
			}
		}

		///@todo add some checking for $vals to be an array?
		function addStruct($vals)
		{
			global $xmlrpcTypes;
			if ($this->mytype==0)
			{
				$this->mytype=$xmlrpcTypes['struct'];
				$this->me['struct']=$vals;
				return 1;
			}
			elseif ($this->mytype==3)
			{
				// we're adding to a struct here
				$this->me['struct'] = array_merge($this->me['struct'], $vals);
			}
			else
			{
				error_log('xmlrpcval: already initialized as a [' . $this->kindOf() . ']');
				return 0;
			}
		}

		function dump($ar)
		{
			//reset($ar);
			//while ( list( $key, $val ) = each( $ar ) )
            foreach ($ar as $key => $val)
			{
				echo "$key => $val<br />";
				if ($key == 'array')
				{
					while ( list( $key2, $val2 ) = each( $val ) )
					{
						echo "-- $key2 => $val2<br />";
					}
				}
			}
		}

		function kindOf()
		{
			switch($this->mytype)
			{
				case 3:
					return 'struct';
					break;
				case 2:
					return 'array';
					break;
				case 1:
					return 'scalar';
					break;
				default:
					return 'undef';
			}
		}

		function serializedata($typ, $val)
		{
			$rs='';
			global $xmlrpcTypes, $xmlrpcBase64, $xmlrpcString,
			$xmlrpcBoolean;
			switch(@$xmlrpcTypes[$typ])
			{
				case 3:
					// struct
					$rs.="<struct>\n";
					//reset($val);
					//while(list($key2, $val2)=each($val))
                    foreach($val as $key2 => $val2)
					{
						$rs.="<member><name>${key2}</name>\n";
						$rs.=$this->serializeval($val2);
						$rs.="</member>\n";
					}
					$rs.='</struct>';
					break;
				case 2:
					// array
					$rs.="<array>\n<data>\n";
					for($i=0; $i<sizeof($val); $i++)
					{
						$rs.=$this->serializeval($val[$i]);
					}
					$rs.="</data>\n</array>";
					break;
				case 1:
					switch ($typ)
					{
						case $xmlrpcBase64:
							$rs.="<${typ}>" . base64_encode($val) . "</${typ}>";
							break;
						case $xmlrpcBoolean:
							$rs.="<${typ}>" . ($val ? '1' : '0') . "</${typ}>";
							break;
						case $xmlrpcString:
							// G. Giunta 2005/2/13: do NOT use htmlentities, since
							// it will produce named html entities, which are invalid xml
							$rs.="<${typ}>" . xmlrpc_encode_entitites($val). "</${typ}>";
							// $rs.="<${typ}>" . htmlentities($val). "</${typ}>";
							break;
						default:
							$rs.="<${typ}>${val}</${typ}>";
					}
					break;
				default:
					break;
			}
			return $rs;
		}

		function serialize()
		{
			return $this->serializeval($this);
		}

		function serializeval($o)
		{
			//global $xmlrpcTypes;
			$rs='';
			$ar=$o->me;
			reset($ar);
			list($typ, $val) = each($ar);            
			$rs.='<value>';
			$rs.=$this->serializedata($typ, $val);
			$rs.="</value>\n";
			return $rs;
		}

		function structmemexists($m)
		{
			return array_key_exists($this->me['struct'][$m]);
        }

		function structmem($m)
		{
			//$nv=$this->me['struct'][$m];
			//return $nv;
            // Faster (?)
            return $this->me['struct'][$m];
		}

		function structreset()
		{
			reset($this->me['struct']);
		}

		function structeach()
		{
			return each($this->me['struct']);
		}

		// DEPRECATED! this code looks like it is very fragile and has not been fixed
        // for a long long time. Shall we remove it for 2.0?
		function getval()
		{
			// UNSTABLE
			global $xmlrpcBoolean, $xmlrpcBase64;
			reset($this->me);
			list($a,$b)=each($this->me);
			// contributed by I Sofer, 2001-03-24
			// add support for nested arrays to scalarval
			// i've created a new method here, so as to
			// preserve back compatibility

			if (is_array($b))
			{
				@reset($b);
				while(list($id,$cont) = @each($b))
				{
					$b[$id] = $cont->scalarval();
				}
			}

			// add support for structures directly encoding php objects
			if (is_object($b))
			{
				$t = get_object_vars($b);
				@reset($t);
				while(list($id,$cont) = @each($t))
				{
					$t[$id] = $cont->scalarval();
				}
				@reset($t);
				while(list($id,$cont) = @each($t))
				{
					eval('$b->'.$id.' = $cont;');
				}
			}
			// end contrib
			return $b;
		}

		function scalarval()
		{
			//global $xmlrpcBoolean, $xmlrpcBase64;
			reset($this->me);
			list(,$b)=each($this->me);
			return $b;
		}

		function scalartyp()
		{
			global $xmlrpcI4, $xmlrpcInt;
			reset($this->me);
			list($a,$b)=each($this->me);
			if ($a==$xmlrpcI4)
			{
				$a=$xmlrpcInt;
			}
			return $a;
		}

		function arraymem($m)
		{
			//$nv=$this->me['array'][$m];
			//return $nv;
            // Faster (?)
            return $this->me['array'][$m];
		}

		function arraysize()
		{
			//reset($this->me);
			//list($a,$b)=each($this->me);
			//return sizeof($b);
            // Faster (?): do not reset array internal pointers
            return count($this->me['array']);
		}

		function structsize()
		{
			//return $this->arraysize();
			return count($this->me['struct']);
        }
	}

	// date helpers
	function iso8601_encode($timet, $utc=0)
	{
		// return an ISO8601 encoded string
		// really, timezones ought to be supported
		// but the XML-RPC spec says:
		//
		// "Don't assume a timezone. It should be specified by the server in its
		// documentation what assumptions it makes about timezones."
		//
		// these routines always assume localtime unless
		// $utc is set to 1, in which case UTC is assumed
		// and an adjustment for locale is made when encoding
		if (!$utc)
		{
			$t=strftime("%Y%m%dT%H:%M:%S", $timet);
		}
		else
		{
			if (function_exists('gmstrftime'))
			{
				// gmstrftime doesn't exist in some versions
				// of PHP
				$t=gmstrftime("%Y%m%dT%H:%M:%S", $timet);
			}
			else
			{
				$t=strftime("%Y%m%dT%H:%M:%S", $timet-date('Z'));
			}
		}
		return $t;
	}

	function iso8601_decode($idate, $utc=0)
	{
		// return a timet in the localtime, or UTC
		$t=0;
		if (ereg("([0-9]{4})([0-9]{2})([0-9]{2})T([0-9]{2}):([0-9]{2}):([0-9]{2})", $idate, $regs))
		{
			if ($utc)
			{
				$t=gmmktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
			}
			else
			{
				$t=mktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
			}
		}
		return $t;
	}

	/****************************************************************
	* xmlrpc_decode takes a message in PHP xmlrpc object format and *
	* tranlates it into native PHP types.                           *
	*                                                               *
	* author: Dan Libby (dan@libby.com)                             *
	****************************************************************/
	function php_xmlrpc_decode($xmlrpc_val)
	{
		$kind = $xmlrpc_val->kindOf();

		if($kind == 'scalar')
		{
			return $xmlrpc_val->scalarval();
		}
		elseif($kind == 'array')
		{
			$size = $xmlrpc_val->arraysize();
			$arr = array();

			for($i = 0; $i < $size; $i++)
			{
				$arr[] = php_xmlrpc_decode($xmlrpc_val->arraymem($i));
			}
			return $arr;
		}
		elseif($kind == 'struct')
		{
			$xmlrpc_val->structreset();
			$arr = array();

			while(list($key,$value)=$xmlrpc_val->structeach())
			{
				$arr[$key] = php_xmlrpc_decode($value);
			}
			return $arr;
		}
	}

	if(function_exists('xmlrpc_decode'))
	{
		define('XMLRPC_EPI_ENABLED','1');
	}
	else
	{
		define('XMLRPC_EPI_ENABLED','0');
	}

	/****************************************************************
	* xmlrpc_encode takes native php types and encodes them into    *
	* xmlrpc PHP object format.                                     *
	* BUG: All sequential arrays are turned into structs.  I don't  *
	* know of a good way to determine if an array is sequential     *
	* only.                                                         *
	*                                                               *
	* feature creep -- could support more types via optional type   *
	* argument.                                                     *
	*                                                               *
	* author: Dan Libby (dan@libby.com)                             *
	****************************************************************/
	function php_xmlrpc_encode($php_val)
	{
		global $xmlrpcInt;
		global $xmlrpcDouble;
		global $xmlrpcString;
		global $xmlrpcArray;
		global $xmlrpcStruct;
		global $xmlrpcBoolean;

		$type = gettype($php_val);
		$xmlrpc_val =& new xmlrpcval;

		switch($type)
		{
			case 'array':
				// PHP arrays can be encoded to either xmlrpc structs or arrays,
				// depending on wheter they are hashes or plain 0..n integer indexed
				// A shorter one-liner would be
				// $tmp = array_diff(array_keys($php_val), range(0, count($php_val)-1));
				// but execution time skyrockets!
				$j = 0;
				$arr = array();
				$ko = false;
				foreach($php_val as $key => $val)
				{
					$arr[$key] =& php_xmlrpc_encode($val);
					if (!$ko && $key !== $j)
					{
						$ko = true;
					}
					$j++;
				}
				if ($ko)
				{
					$xmlrpc_val->addStruct($arr);
				}
				else
				{
					$xmlrpc_val->addArray($arr);
				}
				break;
			case 'object':
				if (is_a($php_val, 'xmlrpcval'))
				{
					$xmlrpc_val = $php_val;
				}
				else
				{
					$arr = array();
					while (list($k,$v) = each($php_val))
					{
						$arr[$k] = php_xmlrpc_encode($v);
					}
					$xmlrpc_val->addStruct($arr);
				}
				break;
			case 'integer':
				$xmlrpc_val->addScalar($php_val, $xmlrpcInt);
				break;
			case 'double':
				$xmlrpc_val->addScalar($php_val, $xmlrpcDouble);
				break;
			case 'string':
				$xmlrpc_val->addScalar($php_val, $xmlrpcString);
				break;
				// <G_Giunta_2001-02-29>
				// Add support for encoding/decoding of booleans, since they are supported in PHP
			case 'boolean':
				$xmlrpc_val->addScalar($php_val, $xmlrpcBoolean);
				break;
				// </G_Giunta_2001-02-29>
			// catch "resource", "NULL", "user function", "unknown type"
			//case 'unknown type':
			default:
				// giancarlo pinerolo <ping@alt.it>
				// it has to return
				// an empty object in case (which is already
				// at this point), not a boolean.
				break;
			}
			return $xmlrpc_val;
	}

/**
* decode a string that is encoded w/ "chunked" transfer encoding
* as defined in rfc2068 19.4.6
* code shamelessly stolen from nusoap library by Dietrich Ayala
*
* @param   string $buffer the string to be decoded
* @return  string
*/
function decode_chunked($buffer){
	// length := 0
	$length = 0;
	$new = '';
	
	// read chunk-size, chunk-extension (if any) and crlf
	// get the position of the linebreak
	$chunkend = strpos($buffer,"\r\n") + 2;
	$temp = substr($buffer,0,$chunkend);
	$chunk_size = hexdec( trim($temp) );
	$chunkstart = $chunkend;
	// while (chunk-size > 0) {
	while ($chunk_size > 0) {

		$chunkend = strpos( $buffer, "\r\n", $chunkstart + $chunk_size);

		// just in case we got a broken connection
		if ($chunkend == false) {
			$chunk = substr($buffer,$chunkstart);
			// append chunk-data to entity-body
			$new .= $chunk;
			$length += strlen($chunk);
			break;
		}

		// read chunk-data and crlf
		$chunk = substr($buffer,$chunkstart,$chunkend-$chunkstart);
		// append chunk-data to entity-body
		$new .= $chunk;
		// length := length + chunk-size
		$length += strlen($chunk);
		// read chunk-size and crlf
		$chunkstart = $chunkend + 2;

		$chunkend = strpos($buffer,"\r\n",$chunkstart)+2;
		if ($chunkend == false) {
			break; //just in case we got a broken connection
		}
		$temp = substr($buffer,$chunkstart,$chunkend-$chunkstart);
		$chunk_size = hexdec( trim($temp) );
		$chunkstart = $chunkend;
	}
	return $new;
}

/**
* Given a PHP function, register a PHP wrapper function that can be exposed
* as xmlrpc method from an xmlrpc_server object.
*
* Known limitations:
* - requires PHP 5.0
* - only works for user-defined functions, not for PHP internal functions
*   (reflection does not support retrieving number/type of params for those)
* - since php functions parameters have no declared types, we cannot
*   reliably build a dispatch map to be used by the server to validate calls to
*   the new method. All we can do is check if the correct number of parameters
*   has been passed to the xmlrpc method.
*   If the end user wants to add a method signature by hand, he is welcome.
* - functions returning objects will NOT generate xmlrpc methods returning php objects
*
* @return the name of the new php function to be used in server dispatch map
*         or false on error
*/
  function wrap_php_function($funcname, $newfuncname='')
  {
    global $xmlrpcerr, $xmlrpcstr, $xmlrpcerruser;

    if (version_compare(phpversion(), '5') == -1)
    {
      return false;
    }
    if (!function_exists($funcname))
    {
      return false;
    }
    else
    {
      // determine name of xmlrpc method
      if ($newfuncname == '')
      {
        $xmlrpcfuncname = "xmlrpc_$funcname";
      }
      else
        $xmlrpcfuncname = $newfuncname;
      if (function_exists($xmlrpcfuncname))
      {
        ///@todo find a new name
        return false;
      }
      $code = "function $xmlrpcfuncname(\$msg) {\n";

      // introspect PHP method and build php string to be eval'd
      $innercode = '';
      $func = new ReflectionFunction($funcname);
      if ($func->isInternal())
      {
        // Note: from PHP 5.1.0 onward, we will possibly be able to use invokeargs
        // instead of getparameters to fully reflect internal php functions ?
        return false;
      }
      $params = $func->getParameters();

      $i = 0;
      $parsvariations = array();
      $pars = array();
      $pnum = count($params);
      foreach ($params as $param)
      {
        if ($param->isOptional())
        {
          // this particular parameter is optioanal. save as valid previous list of parameters
          $innercode .= "if (\$paramcount > $i) {\n";
          $parsvariations[] = $pars;
        }
        $innercode .= "\$p$i = \$msg->getParam($i);\n";
        $innercode .= "if (\$p{$i}->kindOf() == 'scalar') \$p$i = \$p{$i}->scalarval(); else \$p$i = php_xmlrpc_decode(\$p$i);\n";
        $pars[] = "\$p$i";
        $i++;
        if ($param->isOptional())
        {
          $innercode .= "}\n";
        }
        if ($i == $pnum)
        {
          // last allowed parameters combination
          $parsvariations[] = $pars;
        }
      }

      if (count($parsvariations) == 0)
      {
        // only known good synopsis = no parameters
        $parsvariations[] = array();
        $minpars = 0;
      }
      else
      {
        $minpars = count($parsvariations[0]);
      }

      if ($minpars)
      {
        // add to code the check for min params number
        // NB: this check needs to be done BEFORE decoding param values
        $innercode = "\$paramcount = \$msg->getNumParams();\n" .
          "if (\$paramcount < $minpars) return new xmlrpcresp(0, {$xmlrpcerr['incorrect_params']}, '{$xmlrpcstr['incorrect_params']}');\n" . $innercode;
      }
      else
        $innercode = "\$paramcount = \$msg->getNumParams();\n" . $innercode;

      $innercode .= "\$np = false;";
      foreach ($parsvariations as $pars)
      {
        $innercode .= "if (\$paramcount == " . count($pars) . ") \$retval = $funcname(" . implode(',', $pars) . "); else\n";
      }
      $innercode .= "\$np = true;\n";
      $innercode .= "if (\$np) return new xmlrpcresp(0, {$xmlrpcerr['incorrect_params']}, '{$xmlrpcstr['incorrect_params']}'); else\n";
      //$innercode .= "if (\$_xmlrpcs_error_occurred) return new xmlrpcresp(0, $xmlrpcerruser, \$_xmlrpcs_error_occurred); else\n";
      $innercode .= "return new xmlrpcresp(php_xmlrpc_encode(\$retval));";
      // shall we exclude functions returning by ref?
      // if($func->returnsReference())
      //  return false;
      $code = $code . $innercode . "\n}";
//print_r($code);
      eval($code);
      // alternative
      //$xmlrpcfuncname = create_function('$m', $innercode);
      return $xmlrpcfuncname;
    }
  }

/**
* Given an xmlrpc client and a method name, register a php wrapper function
* that will call it and return results using native php types for both
* params and results. The generated php function will return an xmlrpcresp
* oject for failed xmlrpc calls
*
* Known limitations:
* - server must support system.methodsignature for the wanted xmlrpc method
* - for methods that expose many signatures, only one can be picked (we
*   could in priciple check if signatures differ only by number of params
*   and not by type, but it would be more complication than we can spare time)
* - nested xmlrpc params: the caller of the generated php function has to
*   encode on its own the params passed to the php function if these are structs
*   or arrays whose (sub)members include values of type datetime or base64
*
* Notes: the connection properties of the given client will be copied
* and reused for the connection used during the call to the generated
* php function.
* Calling the generated php function 'might' be slow: a new xmlrpc client
* is created on every invocation and an xmlrpc-connection opened+closed.
* An extra 'debug' param is appended to param list of xmlrpc method, useful
* for debugging purposes.
*
* @param xmlrpc_client $client     an xmlrpc client set up correctly to communicate with target server
* @param string        $methodname the xmlrpc method to be mapped to a php function
* @param integer       $signum     the index of the method signature to use in mapping (if method exposes many sigs)
* @return                          the name of the generated php function or false
*/
  function wrap_xmlrpc_method($client, $methodname, $signum=0, $timeout=0, $protocol='http', $newfuncname='')
  {
    $msg =& new xmlrpcmsg('system.methodSignature');
    $msg->addparam(new xmlrpcval($methodname));
    $response =& $client->send($msg, $timeout, $protocol);
    if (!$response || $response->faultCode())
    {
      return false;
    }
    else
    {
      $desc = $response->value();
      if ($desc->kindOf() != 'array' || $desc->arraysize() <= $signum)
        return false;
      else
      {
        if ($newfuncname != '')
          $xmlrpcfuncname = $newfuncname;
        else
          $xmlrpcfuncname = 'xmlrpc_'.str_replace('.', '_', $methodname);
        if (function_exists($xmlrpcfuncname)) {
          ///@todo find a suitably different name
          return false;
        }
        $desc = $desc->arraymem($signum);
        $code = "function $xmlrpcfuncname (";
        $innercode = "\$client =& new xmlrpc_client('$client->path', '$client->server');\n";
        // copy all client fields to the client that will be generated runtime
        // (this provieds for future expansion of client obj)
        foreach($client as $fld => $val)
        {
          if ($fld != 'debug')
          {
            $val = var_export($val, true);
            $innercode .= "\$client->$fld = $val;\n";
          }
        }
        $innercode .= "\$client->setDebug(\$debug);\n";
        ///@todo copy other properties from current client, e.g. SSL, proxy etc...
        $innercode .= "\$msg =& new xmlrpcmsg('$methodname');\n";

        // param parsing
        $plist = array();
        $pcount = $desc->arraysize();
        for($i = 1; $i < $pcount; $i++)
        {
          $plist[] = "\$p$i";
          $ptype = $desc->arraymem($i);
          $ptype = $ptype->scalarval();
          if ($ptype == 'dateTime.iso8601' || $ptype == 'base64')
          {
            $innercode .= "\$p$i =& new xmlrpcval(\$p$i, '$ptype');\n";
          }
          else
          {
            $innercode .= "\$p$i =& php_xmlrpc_encode(\$p$i);\n";
          }
          $innercode .= "\$msg->addparam(\$p$i);\n";
        }
        $plist[] = '$debug = false';
        $plist = implode(',', $plist);

        $innercode .= "\$res =& \$client->send(\$msg, $timeout, '$protocol');\n";
        $innercode .= "if (\$res->faultcode()) return \$res; else return php_xmlrpc_decode(\$res->value());";

        $code = $code . $plist. ") {\n" . $innercode . "\n}";
//print_r($code);
        eval($code);
        // alternative
        //$xmlrpcfuncname = create_function('$m', $innercode);
        return $xmlrpcfuncname;
      }
    }
  }

?>